// DEFINE SOME CONSTANTS
const int cGoldAmtDwarven=1000;
const int cGoldAmtTiny=1500;
const int cGoldAmtSmall=3000;
const int cGoldAmtLarge=6000;

const int cVeryShort=3;
const int cShort=10;
const int cMedium=20;
const int cLong=40;
const int cVeryLong=80;

// GLOBALS ***************************************************
int MapSkin = 1;
int SeaOrLand = 1;  // SEA=1 LAND=0
float SeaLevel = -6;
int WaterOnMap = 0;
int failCount=0;


// DECLARE OUR CONSTRAINTS GLOBAL SO WE CAN USE IN FUNCTIONS
// Keep Things Off The Map Edges
int avoidMapEdgesVeryShort=cVeryShort;
int avoidMapEdgesShort=cShort;
int avoidMapEdgesMedium=cMedium;
int avoidMapEdgesLong=cLong;
int avoidMapEdgesVeryLong=cVeryLong;

// Used For Various Land Masses
int avoidLandAreaShort=cShort;
int avoidLandAreaMedium=cMedium;
int avoidLandAreaLong=cLong;

// Used For Various Cliffs/Gorges
int avoidCliffsGorgesShort=cShort;
int avoidCliffsGorgesMedium=cMedium;
int avoidCliffsGorgesLong=cLong;

// Animals
int avoidAnimalsShort=cShort;
int avoidAnimalsMedium=cMedium;
int avoidAnimalsLong=cLong;

// Player Areas Constraint
int avoidPlayerAreasVeryShort=cVeryShort;
int avoidPlayerAreasShort=cShort;
int avoidPlayerAreasMedium=cMedium;
int avoidPlayerAreasLong=cLong;
int avoidPlayerAreasVeryLong=140;
// Player Ramp Constraint
int avoidPlayerRampShort=cShort;
int avoidPlayerRampMedium=cMedium;
int avoidPlayerRampLong=cLong;

// Lakes Constraint
int avoidLakesVeryShort=cVeryShort;
int avoidLakesShort=cShort;
int avoidLakesMedium=cMedium;
int avoidLakesLong=cLong;
int avoidLakesVeryLong=cVeryLong;

// Town Centers constraint.
int avoidTownCentersShort=cShort;
int avoidTownCentersMedium=cMedium;
int avoidTownCentersLong=cLong;

// Building constraints - Used For Additoinal Settlements
int avoidBuildingsVeryShort=cVeryShort;
int avoidBuildingsShort=cShort;
int avoidBuildingsMedium=cMedium;
int avoidBuildingsLong=cLong;
int avoidBuildingsVeryLong=cVeryLong;

// Gold
int avoidGoldShort=cShort;
int avoidGoldMedium=cMedium;
int avoidGoldLong=cLong;

// Relics
int avoidRelicShort=cShort;
int avoidRelicMedium=cMedium;
int avoidRelicLong=cLong;

// Avoid impassable land
int avoidImpassableLandShort=cShort;
int avoidImpassableLandMedium=cMedium;
int avoidImpassableLandLong=cLong;

// Forests
int avoidForestShort=cShort;
int avoidForestMedium=cMedium;
int avoidForestLong=cLong;

// Avoid Water
int avoidWaterVeryShort=cVeryShort;
int avoidWaterShort=cShort;
int avoidWaterMedium=cMedium;
int avoidWaterLong=cLong;

// Near To Water
int nearShoreLineVeryShort=cVeryShort;
int nearShoreLineShort=cShort;
int nearShoreLineMedium=cMedium;
int nearShoreLineLong=cLong;

// Near Land
int nearLandVeryShort=cVeryShort;
int nearLandShort=cShort;
int nearLandMedium=cMedium;
int nearLandLong=cLong;

// Avoid All Objects
int avoidAllVeryShort=cVeryShort;
int avoidAllShort=cShort;
int avoidAllMedium=cMedium;
int avoidAllLong=cLong;

// Random Tree Id's
int idTree1=0;
int idTree2=0;
int idTree3=0;
int idTree4=0;

float iifF(bool cond=true, float val1=0, float val2=0) {
   if (cond==true) return(val1);
   else return(val2);
}

float min(float val1=0, float val2=0) {
   if (val1>val2) return (val2+0.0);
   else return(val1+0.0);
}
float max(float val1=0, float val2=0) {
   if (val1<val2) return (val2+0.0);
   else return(val1+0.0);
}

/* MATH FUNCTIONS  ************************************/
float sin(float Angle=0) {
   float MyAngle=Angle % 360; //iifF(Angle>360,Angle-360,Angle);
   if (MyAngle<=    0) return(.00000000000000);
   else if (MyAngle<=    5) return(.08715574274766);
   else if (MyAngle<=    10) return(.17364817766693);
   else if (MyAngle<=    15) return(.25881904510252);
   else if (MyAngle<=    20) return(.34202014332567);
   else if (MyAngle<=    25) return(.42261826174070);
   else if (MyAngle<=    30) return(.50000000000000);
   else if (MyAngle<=    35) return(.57357643635105);
   else if (MyAngle<=    40) return(.64278760968654);
   else if (MyAngle<=    45) return(.70710678118655);
   else if (MyAngle<=    50) return(.76604444311898);
   else if (MyAngle<=    55) return(.81915204428899);
   else if (MyAngle<=    60) return(.86602540378444);
   else if (MyAngle<=    65) return(.90630778703665);
   else if (MyAngle<=    70) return(.93969262078591);
   else if (MyAngle<=    75) return(.96592582628907);
   else if (MyAngle<=    80) return(.98480775301221);
   else if (MyAngle<=    85) return(.99619469809175);
   else if (MyAngle<=    90) return(1.00000000000000);
   else if (MyAngle<=    95) return(.99619469809175);
   else if (MyAngle<=    100) return(.98480775301221);
   else if (MyAngle<=    105) return(.96592582628907);
   else if (MyAngle<=    110) return(.93969262078591);
   else if (MyAngle<=    115) return(.90630778703665);
   else if (MyAngle<=    120) return(.86602540378444);
   else if (MyAngle<=    125) return(.81915204428899);
   else if (MyAngle<=    130) return(.76604444311898);
   else if (MyAngle<=    135) return(.70710678118655);
   else if (MyAngle<=    140) return(.64278760968654);
   else if (MyAngle<=    145) return(.57357643635105);
   else if (MyAngle<=    150) return(.50000000000000);
   else if (MyAngle<=    155) return(.42261826174070);
   else if (MyAngle<=    160) return(.34202014332567);
   else if (MyAngle<=    165) return(.25881904510252);
   else if (MyAngle<=    170) return(.17364817766693);
   else if (MyAngle<=    175) return(.08715574274766);
   else if (MyAngle<=    180) return(.00000000000000);
   else if (MyAngle<=    185) return(-.08715574274766);
   else if (MyAngle<=    190) return(-.17364817766693);
   else if (MyAngle<=    195) return(-.25881904510252);
   else if (MyAngle<=    200) return(-.34202014332567);
   else if (MyAngle<=    205) return(-.42261826174070);
   else if (MyAngle<=    210) return(-.50000000000000);
   else if (MyAngle<=    215) return(-.57357643635105);
   else if (MyAngle<=    220) return(-.64278760968654);
   else if (MyAngle<=    225) return(-.70710678118655);
   else if (MyAngle<=    230) return(-.76604444311898);
   else if (MyAngle<=    235) return(-.81915204428899);
   else if (MyAngle<=    240) return(-.86602540378444);
   else if (MyAngle<=    245) return(-.90630778703665);
   else if (MyAngle<=    250) return(-.93969262078591);
   else if (MyAngle<=    255) return(-.96592582628907);
   else if (MyAngle<=    260) return(-.98480775301221);
   else if (MyAngle<=    265) return(-.99619469809175);
   else if (MyAngle<=    270) return(-1.00000000000000);
   else if (MyAngle<=    275) return(-.99619469809175);
   else if (MyAngle<=    280) return(-.98480775301221);
   else if (MyAngle<=    285) return(-.96592582628907);
   else if (MyAngle<=    290) return(-.93969262078591);
   else if (MyAngle<=    295) return(-.90630778703665);
   else if (MyAngle<=    300) return(-.86602540378444);
   else if (MyAngle<=    305) return(-.81915204428899);
   else if (MyAngle<=    310) return(-.76604444311898);
   else if (MyAngle<=    315) return(-.70710678118655);
   else if (MyAngle<=    320) return(-.64278760968654);
   else if (MyAngle<=    325) return(-.57357643635105);
   else if (MyAngle<=    330) return(-.50000000000000);
   else if (MyAngle<=    335) return(-.42261826174070);
   else if (MyAngle<=    340) return(-.34202014332567);
   else if (MyAngle<=    345) return(-.25881904510252);
   else if (MyAngle<=    350) return(-.17364817766693);
   else if (MyAngle<=    355) return(-.08715574274766);
   else if (MyAngle<=    360) return(.00000000000000);
}
float cos(float Angle=0) {
   float MyAngle=iifF(Angle>360,Angle-360,Angle);
   if (MyAngle<=    0) return(1.00000000000000);
   else if (MyAngle<=    5) return(.99619469809175);
   else if (MyAngle<=    10) return(.98480775301221);
   else if (MyAngle<=    15) return(.96592582628907);
   else if (MyAngle<=    20) return(.93969262078591);
   else if (MyAngle<=    25) return(.90630778703665);
   else if (MyAngle<=    30) return(.86602540378444);
   else if (MyAngle<=    35) return(.81915204428899);
   else if (MyAngle<=    40) return(.76604444311898);
   else if (MyAngle<=    45) return(.70710678118655);
   else if (MyAngle<=    50) return(.64278760968654);
   else if (MyAngle<=    55) return(.57357643635105);
   else if (MyAngle<=    60) return(.50000000000000);
   else if (MyAngle<=    65) return(.42261826174070);
   else if (MyAngle<=    70) return(.34202014332567);
   else if (MyAngle<=    75) return(.25881904510252);
   else if (MyAngle<=    80) return(.17364817766693);
   else if (MyAngle<=    85) return(.08715574274766);
   else if (MyAngle<=    90) return(.00000000000000);
   else if (MyAngle<=    95) return(-.08715574274766);
   else if (MyAngle<=    100) return(-.17364817766693);
   else if (MyAngle<=    105) return(-.25881904510252);
   else if (MyAngle<=    110) return(-.34202014332567);
   else if (MyAngle<=    115) return(-.42261826174070);
   else if (MyAngle<=    120) return(-.50000000000000);
   else if (MyAngle<=    125) return(-.57357643635105);
   else if (MyAngle<=    130) return(-.64278760968654);
   else if (MyAngle<=    135) return(-.70710678118655);
   else if (MyAngle<=    140) return(-.76604444311898);
   else if (MyAngle<=    145) return(-.81915204428899);
   else if (MyAngle<=    150) return(-.86602540378444);
   else if (MyAngle<=    155) return(-.90630778703665);
   else if (MyAngle<=    160) return(-.93969262078591);
   else if (MyAngle<=    165) return(-.96592582628907);
   else if (MyAngle<=    170) return(-.98480775301221);
   else if (MyAngle<=    175) return(-.99619469809175);
   else if (MyAngle<=    180) return(-1.00000000000000);
   else if (MyAngle<=    185) return(-.99619469809175);
   else if (MyAngle<=    190) return(-.98480775301221);
   else if (MyAngle<=    195) return(-.96592582628907);
   else if (MyAngle<=    200) return(-.93969262078591);
   else if (MyAngle<=    205) return(-.90630778703665);
   else if (MyAngle<=    210) return(-.86602540378444);
   else if (MyAngle<=    215) return(-.81915204428899);
   else if (MyAngle<=    220) return(-.76604444311898);
   else if (MyAngle<=    225) return(-.70710678118655);
   else if (MyAngle<=    230) return(-.64278760968654);
   else if (MyAngle<=    235) return(-.57357643635105);
   else if (MyAngle<=    240) return(-.50000000000000);
   else if (MyAngle<=    245) return(-.42261826174070);
   else if (MyAngle<=    250) return(-.34202014332567);
   else if (MyAngle<=    255) return(-.25881904510252);
   else if (MyAngle<=    260) return(-.17364817766693);
   else if (MyAngle<=    265) return(-.08715574274766);
   else if (MyAngle<=    270) return(.00000000000000);
   else if (MyAngle<=    275) return(.08715574274766);
   else if (MyAngle<=    280) return(.17364817766693);
   else if (MyAngle<=    285) return(.25881904510252);
   else if (MyAngle<=    290) return(.34202014332567);
   else if (MyAngle<=    295) return(.42261826174070);
   else if (MyAngle<=    300) return(.50000000000000);
   else if (MyAngle<=    305) return(.57357643635105);
   else if (MyAngle<=    310) return(.64278760968654);
   else if (MyAngle<=    315) return(.70710678118655);
   else if (MyAngle<=    320) return(.76604444311898);
   else if (MyAngle<=    325) return(.81915204428899);
   else if (MyAngle<=    330) return(.86602540378444);
   else if (MyAngle<=    335) return(.90630778703665);
   else if (MyAngle<=    340) return(.93969262078591);
   else if (MyAngle<=    345) return(.96592582628907);
   else if (MyAngle<=    350) return(.98480775301221);
   else if (MyAngle<=    355) return(.99619469809175);
   else if (MyAngle<=    360) return(1.00000000000000);
}
float GetXPointOnCircle(float Angle=0, float Radius=0, float AtX=.5) {
   float MyX = (Radius * cos(Angle) + AtX); // FIND X AT CIRCLES EDGE
   MyX = iifF(MyX<0,0,MyX);
   MyX = iifF(MyX>1,1,MyX);
   return (MyX);
}
float GetZPointOnCircle(float Angle=0, float Radius=0, float AtZ=.5) {
   float MyZ = (Radius * sin(Angle) + AtZ); // FIND Z AT CIRCLES EDGE
   MyZ = iifF(MyZ<0,0,MyZ);
   MyZ = iifF(MyZ>1,1,MyZ);
   return (MyZ);
}
int ObjectsInACircle(int id=0, float StartAngle=0, float EndAngle=0, float AngleBetween=0, float Radius=0, float StartX=.5, float StartZ=.5, int PlayerId=0, int Count=0) {
   // RADIUS AS FRACTION, WIDTH IN METERS
   float ThisAngle=iifF(EndAngle<StartAngle,(EndAngle+360)-StartAngle,EndAngle-StartAngle);
   int NumberOfAngles = (ThisAngle)/AngleBetween; // NUMBER OF ANGLES BETWEEN
   ThisAngle = StartAngle;
   for (i=0; <=NumberOfAngles) {
      float MyAtX=GetXPointOnCircle(ThisAngle, Radius, StartX);
      float MyAtZ=GetZPointOnCircle(ThisAngle, Radius, StartZ);
      ThisAngle=ThisAngle+AngleBetween;
      rmPlaceObjectDefAtLoc(id, PlayerId, MyAtX, MyAtZ, Count);
   }
   return(id);
}
int ObjectsInALine(int id=0, float Angle=0, float LineLength=0, float SpaceBetween=20, float StartX=.5, float StartZ=.5, int PlayerId=0) {
   // LineLength AS FRACTION, SPACEBETWEEN AS METERS!
   float MyLineLength = LineLength;
   float NextPoint=0;
   int NumberOfPoints = MyLineLength/SpaceBetween; // NUMBER OF PEAKS
   for (i=1; <=NumberOfPoints) {
      NextPoint = rmZMetersToFraction(i * SpaceBetween);
      float MyAtX=GetXPointOnCircle(Angle, NextPoint, StartX);
      float MyAtZ=GetZPointOnCircle(Angle, NextPoint, StartZ);
      rmPlaceObjectDefAtLoc(id, PlayerId, MyAtX, MyAtZ, 1);
   }
}
/* SKINNING FUNCTIONS  ************************************/
float GetAnimalCount(string Animal="") {
   // RETURNS THE FOOD VALUE FOR FOOD TYPES, OR HIT POINTS FOR PREDATORS
   // USED TO HELP DETERMINE THE NUMBER OF EACH TYPE TO PLACE
   // THESE ARE NUTRITIONAL VALUES
   if (Animal=="Aurochs") return (rmRandInt(2,3)); //(400.0));
   if (Animal=="Baboon") return (rmRandInt(6,12)); //(80.0));
   if (Animal=="Berry Bush") return (rmRandInt(6,12)); //(100.0));
   if (Animal=="Boar") return (rmRandInt(2,5)); //(300.0));
   if (Animal=="Caribou") return (rmRandInt(3,6)); //(150.0));
   if (Animal=="Chicken") return (rmRandInt(7,10)); //(75.0));
   if (Animal=="Cow") return (rmRandInt(2,3)); //(75.0));
   if (Animal=="Crocodile") return (rmRandInt(2,3)); //(200.0));
   if (Animal=="Crowned Crane") return (rmRandInt(5,10)); //(100.0));
   if (Animal=="Deer") return (rmRandInt(4,8)); //(150.0));
   if (Animal=="Elephant") return (rmRandInt(2,3)); //(750.0));
   if (Animal=="Elk") return (rmRandInt(3,5)); //(150.0));
   if (Animal=="Fish - Mahi") return (rmRandInt(1,2)); //(100.0));
   if (Animal=="Fish - Perch") return (rmRandInt(1,2)); //(100.0));
   if (Animal=="Fish - Salmon") return (rmRandInt(1,2)); //(100.0));
   if (Animal=="Gazelle") return (rmRandInt(5,10)); //(100.0));
   if (Animal=="Giraffe") return (rmRandInt(2,4)); //(300.0));
   if (Animal=="Goat") return (rmRandInt(2,3)); //(50.0));
   if (Animal=="Hippo") return (rmRandInt(2,3)); //(400.0));
   if (Animal=="Monkey") return (rmRandInt(6,12)); //(100.0));
   if (Animal=="Pig") return (rmRandInt(2,3)); //(50.0));
   if (Animal=="Rhinocerous") return (rmRandInt(2,3)); //(500.0));
   if (Animal=="Walrus") return (rmRandInt(3,6)); //(100.0));
   if (Animal=="Water Buffalo") return (rmRandInt(2,3)); //(400.0));
   if (Animal=="Zebra") return (rmRandInt(4,7)); //(200.0));
   // THESE ARE HITPOINTS
   if (Animal=="Ape Of Set") return (rmRandInt(1,1)); //(45.0));
   if (Animal=="Bear") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Hyena") return (rmRandInt(2,3)); //(80.0));
   if (Animal=="Hyena Of Set") return (rmRandInt(1,1)); //(45.0));
   if (Animal=="Lion") return (rmRandInt(2,3)); //(60.0));
   if (Animal=="Polar Bear") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Rhinocerous Of Set") return (rmRandInt(2,3)); //(180.0));
   if (Animal=="Shade of erebus") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Serpent") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Wolf") return (rmRandInt(2,3)); //(45.0));
   rmEchoInfo("Animal not found="+Animal);
   return(1000.0);
}
string GetAnimalType(int HerdHuntFishPred=0) {
   // RANDOMLY SELECT AN ANIMAL BASED ON MapSkin
   int ThisSkin=MapSkin;
   int rand=0;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (HerdHuntFishPred==1) { // LOOKING FOR HERDABLE TYPE
      if (ThisSkin==1) {// WINTER HERDABLE
         rand = rmRandInt(1,5);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Pig");
         else if (rand==3) return("goat");
         else if (rand==4) return("Cow");
         else if (rand==5) return("Crowned Crane");
      }
      if (ThisSkin==2) {// SPRING HERDABLE
         rand = rmRandInt(1,5);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
         else if (rand==4) return("Crowned Crane");
         else if (rand==5) return("Chicken");
      }
      if (ThisSkin==3) {// SUMMER HERDABLE
         rand = rmRandInt(1,4);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Cow");
         else if (rand==4) return("Cow");
      }
      if (ThisSkin==4) {// FALL HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
      }
      if (ThisSkin==5) {// MORDOR HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Pig");
      }
   } else if (HerdHuntFishPred==2) { // LOOKING FOR HUNTABLE
      if (ThisSkin==1 || ThisSkin==4) {// WINTER/FALL HUNTABLE
         rand = rmRandInt(1,4+WaterOnMap); // A 1 IF SEA TO POSSIBLY PLACE A WATER TYPE ANIMAL
         if (rand==1) return("Caribou");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Deer");
         else if (rand==4) return("Elk");
      }
      if (ThisSkin==2) {// SPRING HUNTS
         rand = rmRandInt(1,8+WaterOnMap);
         if (rand==1) return("Gazelle");
         else if (rand==2) return("Giraffe");
         else if (rand==3) return("Rhinocerous");
         else if (rand==4) return("Elephant");
         else if (rand==5) return("Hippo");
         else if (rand==6) return("Zebra");
         else if (rand==7) return("Monkey");
         else if (rand==8) return("Baboon");
      }
      if (ThisSkin==3) {// SUMMER HUNTS
         rand = rmRandInt(1,4+WaterOnMap);
         if (rand==1) return("Gazelle");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Boar");
         else if (rand==4) return("Aurochs");
      }
      if (ThisSkin==5) {// MORDOR HUNTABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Baboon");
         else if (rand==2) return("Boar");
         else if (rand==3) return("Rhinocerous");
      }
      rand = rmRandInt(1,2); // IF A SEA MAP, THEN PLACE A WATER TYPE ANIMAL
      if (rand==1) return("Walrus");
      else if (rand==2) return("Water Buffalo");
   } else if (HerdHuntFishPred==3) { // LOOKING FOR FISHABLE
      rand = rmRandInt(1,3);
      if (rand==1) return("Fish - Mahi");
      else if (rand==2) return("Fish - Perch");
      else if (rand==3) return("Fish - Salmon");
   } else if (HerdHuntFishPred==4) { // LOOKING FOR PREDATORS
      rand = rmRandInt(1,500);
      if (rand==1) return("Ape Of Set"); // THROW A MONKEY WRENCH AT EM FROM TIME TO TIME
      if (ThisSkin==1 || ThisSkin==4) {// WINTER/FALL PREDATORS
         rand = rmRandInt(1,3);
         if (rand==1) return("Polar Bear");
         else if (rand==2) return("Wolf");
         else if (rand==3) return("Bear");
      }
      if (ThisSkin==2) {// SPRING PREDATORS
         rand = rmRandInt(1,3+WaterOnMap);
         if (rand==1) return("Hyena");
         else if (rand==2) return("Lion");
         else if (rand==3) return("Serpent");
      }
      if (ThisSkin==3) {// SUMMER PREDATORS
         rand = rmRandInt(1,4+WaterOnMap);
         if (rand==1) return("Wolf");
         else if (rand==2) return("Wolf");
         else if (rand==3) return("Serpent");
         else if (rand==4) return("Bear");
      }
      if (ThisSkin==5) {// MORDOR PREDATORS
         rand = rmRandInt(1,5);
         if (rand==1) return("Serpent");
         else if (rand==2) return("Shade of erebus");
         else if (rand==3) return("Ape Of Set");
         else if (rand==4) return("Hyena Of Set");
         else if (rand==5) return("Rhinoceros Of Set");
      }
      return("Crocodile"); // IF WATER MAP AND NONE SELECTED
   }
}

int CreateAnimals(string ObjName="", int HerdHuntFishPred=0, int MinDist=0, int MaxDist=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string Animal = GetAnimalType(HerdHuntFishPred);
   float NumToPlace = GetAnimalCount(Animal);
   NumToPlace = iifF(NumToPlace<2,2,NumToPlace); // ALWAYS PLACE AT LEAST TWO
   rmEchoInfo("Placing "+NumToPlace+" "+Animal);
   int id=rmCreateObjectDef("Animal"+Animal+ObjName);
   rmAddObjectDefItem(id, Animal, NumToPlace, 3.0 * HerdHuntFishPred);
   rmSetObjectDefMinDistance(id, MinDist);
   rmSetObjectDefMaxDistance(id, MaxDist);
   if (AddToClass>0) rmAddObjectDefToClass(id, AddToClass);
   if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
   if (HerdHuntFishPred==2) {
      rmAddObjectDefConstraint(id, avoidAnimalsMedium);
      rmAddObjectDefConstraint(id, avoidBuildingsMedium);
   } else {
      rmAddObjectDefConstraint(id, avoidAnimalsShort);
      rmAddObjectDefConstraint(id, avoidBuildingsShort);
   }
   if (Animal=="Walrus" || Animal=="Water Buffalo" || Animal=="Crocodile") {
      rmAddObjectDefConstraint(id, nearShoreLineVeryShort);
   } else if (HerdHuntFishPred!=3) { // NOT FISH, AVOID WATERS EDGE
      rmAddObjectDefConstraint(id, avoidWaterVeryShort);
   }
   return(id);
}

void PlaceGold(int Amount=0, int MinDist=0, int MaxDist=0, int idTiny=0, int idSmall=0, int idLarge=0) {
   rmSetObjectDefMinDistance(idTiny,MinDist);
   rmSetObjectDefMaxDistance(idTiny,MaxDist);
   rmSetObjectDefMinDistance(idSmall,MinDist);
   rmSetObjectDefMaxDistance(idSmall,MaxDist);
   rmSetObjectDefMinDistance(idLarge,MinDist);
   rmSetObjectDefMaxDistance(idLarge,MaxDist);
   int RemainAmount = Amount;
   int j=0;
   for (i=1; <cNumberPlayers*2) { // ONLY LOOP SO MANY TIMES REGARDLESS OF REQUEST AMOUNT
      if (RemainAmount < cGoldAmtTiny/2) break; // NOT AT LEAST 1/2 A TINY TO PLACE, SO EXIT LOOP
      if (RemainAmount>=cGoldAmtLarge) j = rmRandInt(2,3); // RANDOMLY PICK ANY SIZE
      else if (RemainAmount>=cGoldAmtSmall) j = rmRandInt(1,2); // RANDOMLY PICK SMALLER SIZE
      else j = 1; // IT"S TINY
      if (j == 1) {
         RemainAmount = RemainAmount - cGoldAmtTiny;
         rmPlaceObjectDefPerPlayer(idTiny,false,1);
      } else if (j == 2) {
         RemainAmount = RemainAmount - cGoldAmtSmall;
         rmPlaceObjectDefPerPlayer(idSmall,false,1);
      } else if (j == 3) {
         RemainAmount = RemainAmount - cGoldAmtLarge;
         rmPlaceObjectDefPerPlayer(idLarge,false,1);
      }
   }
}

void GoldConstr(int id=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   rmAddObjectDefConstraint(id, avoidGoldLong);
   rmAddObjectDefConstraint(id, avoidMapEdgesShort);
   rmAddObjectDefConstraint(id, avoidBuildingsShort);
   rmAddObjectDefConstraint(id, avoidWaterVeryShort);
//   rmAddObjectDefConstraint(id, avoidAllShort);
   if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
}

void CreateGold(int CloseAmount=0, float CloseDist=0, int NearByAmount=0, float NearByDist=0, int FarAmount=0, float FarDist=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   int idTiny = rmCreateObjectDef("GoldTiny");
   rmAddObjectDefItem(idTiny,"Gold Mine Tiny",1,0.0);
   GoldConstr(idTiny, Constraint1, Constraint2, Constraint3, Constraint4);

   int idSmall = rmCreateObjectDef("GoldSmall");
   rmAddObjectDefItem(idSmall,"Gold Mine Small",1,0.0);
   GoldConstr(idSmall, Constraint1, Constraint2, Constraint3, Constraint4);

   int idLarge = rmCreateObjectDef("GoldLarge");
   rmAddObjectDefItem(idLarge,"Gold Mine",1,0.0);
   GoldConstr(idLarge, Constraint1, Constraint2, Constraint3, Constraint4);

   PlaceGold(CloseAmount, 6, CloseDist, idTiny, idSmall, idLarge);
   PlaceGold(NearByAmount, CloseDist, NearByDist, idTiny, idSmall, idLarge);
   PlaceGold(FarAmount, NearByDist, FarDist, idTiny, idSmall, idLarge);
}

string GetBirdType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (rmRandInt(1,10)==1 && MapSkin==5) return("Flying Purple Hippo"); // Whee! - Only MORDER
   if (rmRandInt(1,10)==1) return("Harpy"); // Controlable
   else if (ThisSkin==1) return("Vulture"); // WINTER
   else if (ThisSkin==2) return("Hawk"); // SPRING
   else if (ThisSkin==3) return("Hawk"); // SUMMER
   else if (ThisSkin==4) return("Vulture"); // FALL
   else if (ThisSkin==5) return("Harpy"); // MORDER
}

string GetSeaType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("North Atlantic Ocean"); // WINTER
   else if (ThisSkin==2) return("Red Sea"); // SPRING
   else if (ThisSkin==3) return("Aegean Sea"); // SPRING
   else if (ThisSkin==4) return("Norwegian Sea");// FALL
   else if (ThisSkin==5) return("Styx River"); // MORDOR
}
string GetLakeType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("Norse River"); // WINTER
   else if (ThisSkin==2) return("Savannah Water Hole"); // SPRING
   else if (ThisSkin==3) return("Greek River"); // SUMMER
   else if (ThisSkin==4) return("Norse River");// FALL
   else if (ThisSkin==5) return("Styx River"); // MORDOR
}


string GetLandType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("CliffNorseB"); // WINTER
   else if (ThisSkin==2) return("SavannahA"); // SPRING
   else if (ThisSkin==3) return("GrassA"); // SUMMER
   else if (ThisSkin==4) return("SnowGrass75"); // FALL
   else if (ThisSkin==5) return("ForestFloorDeadPine"); // MORDOR
}

string GetTreeType(int ForestOrTreeType=0) {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ForestOrTreeType==1) { // LOOKING FOR A FOREST TYPE
      if (ThisSkin==1) { // WINTER
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Snow Pine Forest");
         else if (ThisSkin==2) return("Mixed Pine Forest");
      }
      else if (ThisSkin==2) return("Savannah Forest"); // SPRING
      else if (ThisSkin==3) { // SUMMER
         ThisSkin=rmRandInt(1,4);
         if (ThisSkin==1) return("Mixed Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
         else if (ThisSkin==3) return("Oak Forest");
         else if (ThisSkin==4) return("Palm Forest");
      }
      else if (ThisSkin==4) { // FALL
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Autumn Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
      }
      else if (ThisSkin==5) return("Hades Forest"); // MORDOR
   } else { // INDIVIDUAL TREE
      if (ThisSkin==1) return("Pine Snow"); // WINTER
      else if (ThisSkin==2) return("Savannah Tree"); // SPRING
      else if (ThisSkin==3) {
         ThisSkin=rmRandInt(1,3);
         if (ThisSkin==1) return("Oak Tree");
         else if (ThisSkin==2) return("Pine");
         else if (ThisSkin==3) return("Palm");
      }
      else if (ThisSkin==4) {
         ThisSkin=rmRandInt(1,2); // FALL
         if (ThisSkin==1) return("Oak Autumn");
         else if (ThisSkin==2) return("Pine");
      }
      else if (ThisSkin==5) return("Pine Dead"); // MORDOR
   }
}

string GetCliffType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("Norse"); // WINTER
   else if (ThisSkin==2) return("Egyptian"); // SPRING
   else if (ThisSkin==3) return("Greek"); // SUMMER
   else if (ThisSkin==4) return("Norse"); // FALL
   else if (ThisSkin==5) return("Hades"); // MORDOR
}

string GetRockType(string Size="") {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) {
      if (rmRandInt(1,10)>1) return("Rock Granite "+Size); // WINTER
      else return ("Rock River Icy");
   }
   else if (ThisSkin==2 || ThisSkin==3) return("Rock Sandstone "+Size); // SPRING/SUMMER
   else if (ThisSkin==4) return("Rock Limestone "+Size); // FALL
   else if (ThisSkin==5) return("Stalagmite"); // MORDOR
   /* Look into these: Rock Cliff, Rock River Grassy, Rock River Icy, Rock River Sandy, Rock Snow, Rock Symbols */
}

string GetRoadType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("NorseRoadA"); // WINTER
   else if (ThisSkin==2) return("GreekRoadA"); // SPRING
   else if (ThisSkin==3) { // SUMMER
      if (rmRandInt(2,2)==1) return("CityTileA");
      return("CityTileAtlantis");
   }
   else if (ThisSkin==4) return("NorseRoadA"); // FALL
   else if (ThisSkin==5) return("UnderWaterRockC"); // MORDOR
}

string GetWaterPlant(int Lake=0) {
   int WhichPlant=rmRandInt(1,6);
   if (Lake==1) WhichPlant=rmRandInt(1,5);
   if (WhichPlant==1) return("water lilly");
   else if (WhichPlant==2) return("papyrus");
   else if (WhichPlant==3) return("Water decoration");
   else if (WhichPlant==4) return("Water Reeds");
   else if (WhichPlant==5) return("Hawksbill"); // I Know
   else if (WhichPlant==6) return("Seaweed");
}

string GetBigFish() {
   int ThisSkin= rmRandInt(1,3);
   if (ThisSkin==1) return("Orca");
   else if (ThisSkin==2) return("Whale");
   else if (ThisSkin==3) return("Shark");
}

void LayerTerrain(int id=0, float Width=6) {
   // WIDTH IN METERS!! - Layers starting at 0 go from outer edge toward area center
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) { // WINTER
      rmAddAreaTerrainLayer(id,"SnowA",0, Width * .33);
      rmAddAreaTerrainLayer(id,"SnowGrass50",Width * .33,Width * .66);
      rmAddAreaTerrainLayer(id,"SnowGrass25",Width * .66,Width);
   } else if (ThisSkin==2) { // SPRING
      rmAddAreaTerrainLayer(id,"SavannahC",0, Width * .25);
      rmAddAreaTerrainLayer(id,"SavannahD", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SavannahC", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"SavannahB", Width * .75,Width);
   } else if (ThisSkin==3) { // SUMMER
      rmAddAreaTerrainLayer(id,"GrassDirt25",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffGreekB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"GrassDirt50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"GrassDirt25", Width * .75,Width);
   } else if (ThisSkin==4) { // FALL
      rmAddAreaTerrainLayer(id,"SnowGrass75",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SnowGrass50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .75,Width);
   } else if (ThisSkin==5) { // MORDOR
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",0,Width * .5);
      rmAddAreaTerrainLayer(id,"HadesBuildable2",Width * .5,Width);
   }
}

void SetMainLandType(int id=0, int LayerWidth=0, int Height=2, string ForceType="") {
   if (ForceType=="") {
      rmSetAreaTerrainType(id,GetLandType());
      LayerTerrain(id, LayerWidth);
   } else {
      rmSetAreaTerrainType(id,ForceType);
   }
   rmSetAreaSmoothDistance(id,6);
   rmSetAreaBaseHeight(id,Height);
}

void AddRocks(int Num=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string type="sprite";
   for (i=1; <=3) {
      if (i==2) type="small";
      else if (i==3) type="big";
      if (Num>0) {
         int id=rmCreateObjectDef("rock "+type);
         rmAddObjectDefItem(id, GetRockType(type), 1, 0.0);
         rmSetObjectDefMinDistance(id, 0.0);
         rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
         if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
         if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
         if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
         if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, Num);
      }
   }
}


/* AREA FUNCTIONS  ************************************/
int CreateAreaAtXZ(string ObjName="", float AtX=.5, float AtZ=.5, float WidthX=0, float WidthZ=0, float HeightBlend=2, float Coherence=1, int ParentArea=0) {
   int id = 0;
   if (ParentArea>0) id = rmCreateArea(ObjName, ParentArea);
   else id = rmCreateArea(ObjName);
   rmSetAreaHeightBlend(id,HeightBlend);
   if (AtX>-1 && AtZ>-1) rmSetAreaLocation(id,AtX,AtZ);
   rmSetAreaSize(id,WidthX,WidthZ);
   rmSetAreaCoherence(id,Coherence);
   return (id);
}

void BlobulateArea(int id=0, int MinBlobs=0, int MinBlobDist=0,  int MaxBlobs=0, int MaxBlobDist=0) {
   rmSetAreaMinBlobs(id,MinBlobs);
   rmSetAreaMaxBlobs(id,MaxBlobs);
   rmSetAreaMinBlobDistance(id, MinBlobDist);
   rmSetAreaMaxBlobDistance(id, MaxBlobDist);
}

void LandArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float WidthX=0, float WidthZ=0, int AddToClass=0, int ParentArea=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   float ThisHeight=0;
   for(i=0; <numAreas) {
      int id = CreateAreaAtXZ(ObjName+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 3, 0, ParentArea);
      rmSetAreaWarnFailure(id, false);
      ThisHeight=rmRandFloat(MinHeight, MaxHeight);
      rmSetAreaSmoothDistance(id, 10);
      BlobulateArea(id, 1, rmRandInt(10, 16),  rmRandInt(3, 10), rmRandInt(16, 25));
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      SetMainLandType(id, 6, ThisHeight);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}


void CliffArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float WidthX=0, float WidthZ=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   failCount=0;
   float NumEdges=rmRandFloat(1,4);
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+i, -1, -1, rmXMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 1, 0);
      rmSetAreaWarnFailure(id, false);
      BlobulateArea(id, 3, rmRandInt(3, 5),  rmRandInt(10, 15), rmRandInt(15, 40));
      rmSetAreaSmoothDistance(id, 10);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      rmSetAreaCliffType(id, GetCliffType());
      rmSetAreaCliffEdge(id, NumEdges, 1.0/NumEdges, 0.1, 1.0, 0);
      rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(id, rmRandInt(MinHeight,MaxHeight), 1.0, 1.0);
      LayerTerrain(id, 6);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}

void RandomTrees() {
   rmSetObjectDefMinDistance(idTree1, 35);
   rmSetObjectDefMaxDistance(idTree1, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree2, 35);
   rmSetObjectDefMaxDistance(idTree2, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree3, 35);
   rmSetObjectDefMaxDistance(idTree3, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree4, 35);
   rmSetObjectDefMaxDistance(idTree4, rmZFractionToMeters(.5));
   rmPlaceObjectDefPerPlayer(idTree1, false, 5);
   rmPlaceObjectDefPerPlayer(idTree2, false, 5);
   rmPlaceObjectDefPerPlayer(idTree3, false, 5);
   rmPlaceObjectDefPerPlayer(idTree4, false, 5);

   rmSetObjectDefMinDistance(idTree1, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree1, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmSetObjectDefMinDistance(idTree2, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree2, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmSetObjectDefMinDistance(idTree3, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree3, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmSetObjectDefMinDistance(idTree4, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree4, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmPlaceObjectDefPerPlayer(idTree1, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree2, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree3, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree4, false, 7); // FOR THE PLAYER AREAS
}

void ForestArea(string ObjName="", int numAreas=0, float WidthX=0, float WidthZ=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0, int ParentArea=0) {
   failCount=0;
   float ThisHeight=0;
   float NumCliffs=rmRandFloat(1,3);
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+"Forest"+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 2, 0, ParentArea);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass); // ONLY ADD INPASSABLE FOREST TO CLASS
      rmSetAreaWarnFailure(id, false);
      LayerTerrain(id, 6);
      BlobulateArea(id, 1, rmRandInt(10, 16),  rmRandInt(3, 10), rmRandInt(16, 25));
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
      int fid = CreateAreaAtXZ(ObjName+"ImpassForest"+i, -1, -1, rmZMetersToFraction(WidthX/5), rmZMetersToFraction(WidthZ/5), 2, 0, id);
      rmSetAreaWarnFailure(fid, false);
      rmSetAreaForestType(fid,GetTreeType(1));
      if(rmBuildArea(fid)==false) { // Stop trying once we fail X times in a row.
         failCount++;
         if (failCount==5) break;
      } else failCount=0;
      rmPlaceObjectDefInArea(idTree1,0,id,WidthX * WidthZ/2);
      rmPlaceObjectDefInArea(idTree2,0,id,WidthX * WidthZ/2);
      rmPlaceObjectDefInArea(idTree3,0,id,WidthX * WidthZ/2);
      rmPlaceObjectDefInArea(idTree4,0,id,WidthX * WidthZ/2);
   }
}

void BeautifyWater(string ObjName="", int id=0, int AddFish=0,  int Embellish=0, int Class=0) {
   int NumToPlace = rmRandInt(AddFish,AddFish*1.2); // USE A 20% VARIANCE ON THE NUMBER PLACE; REQUEST FOR 10 TO GET 10-12
   if (NumToPlace>0) { // ADD SOME FISH TO THE WATER
      int fishid = rmCreateObjectDef(ObjName+"fish");
      rmAddObjectDefItem(fishid,GetAnimalType(3),1,0.0);
      if (Class==0) rmPlaceObjectDefInArea(fishid, 0, id, NumToPlace);
      else rmPlaceObjectDefInRandomAreaOfClass(fishid, 0, id, NumToPlace);
   }
   NumToPlace = rmRandInt(Embellish,Embellish*1.2); // USE A 20% VARIANCE ON THE NUMBER PLACE; REQUEST FOR 10 TO GET 10-12
   if (NumToPlace>0) { // ADD SOME PLANT LIFE TO THE WATER
      int plantid = rmCreateObjectDef(ObjName+"plant");
      rmAddObjectDefItem(plantid,GetWaterPlant(),3,1.0); // 3 per
      if (Class==0) rmPlaceObjectDefInArea(plantid, 0, id, NumToPlace);
      else rmPlaceObjectDefInRandomAreaOfClass(plantid, 0, id, NumToPlace);
   }
}

void WaterArea(string ObjName="", int numAreas=0, float WidthX=0, float WidthZ=0, int AddFish=0, int Embellish=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0) {
   failCount=0;
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+"water"+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 3, 0);
rmEchoInfo(ObjName+"Water"+i+" X="+WidthX);
rmEchoInfo(ObjName+"Water"+i+" Z="+WidthZ);
      rmSetAreaWarnFailure(id, false);
      rmSetAreaWaterType(id, GetLakeType());
      //rmSetAreaBaseHeight(id,SeaLevel+4);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (SeaOrLand==1) rmAddAreaConstraint(id, avoidWaterLong);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else {
         failCount=0;
         int iAddFish = (WidthX * WidthZ)/30;
         for(j=1; <=iAddFish) BeautifyWater(ObjName+"fish"+i+"_"+j, id, 1, 0);
         for(j=1; <=iAddFish) BeautifyWater(ObjName+"plants"+i+"_"+j, id, 0, 1);
      }
   }
}

void FlamingMoat(string ObjName="",float Angle=0, float AngleBetween=0, float Radius=0, float AtX=0, float AtZ=0) {
   int id = rmCreateObjectDef(ObjName);
   rmAddObjectDefItem(id,"Fire Hades",3,1.0);
   ObjectsInACircle(id, Angle+20, Angle-20, AngleBetween, Radius, AtX, AtZ, 0, 1);
}

void PlayerStash(string ObjName="", float AtX=0, float AtZ=0, int Constraint1=0) {
   int id = CreateAreaAtXZ("PlayerStash"+ObjName, AtX, AtZ, rmZMetersToFraction(2),rmZMetersToFraction(2), 2, 1);
   rmSetAreaForestType(id, GetTreeType(1));
   SetMainLandType(id, 6, 0);
   rmSetAreaBaseHeight(id,SeaLevel+3);
   rmBuildArea(id);
   id = CreateAreaAtXZ("FoodStash"+ObjName, AtX, AtZ, rmZMetersToFraction(3),rmZMetersToFraction(3), 2, 1);
   rmBuildArea(id);
   int xid = rmCreateObjectDef(ObjName);
   rmAddObjectDefItem(xid,"Berry Bush",5,.5);
   rmAddObjectDefConstraint(xid, rmCreateTypeDistanceConstraint("Avoid trees"+ObjName, "tree", .5));
   if (Constraint1>0) rmAddObjectDefConstraint(xid, Constraint1);
   rmPlaceObjectDefInArea(xid,0,id,20);
}

void BuildMountainAtXZ(string ObjName="", float Angle=0, float AtX=0, float AtZ=0, float BaseWidth=0, float Height=0, int Steps=0, int PlayerId=0, int classPlayer=0) {
   // WIDTH HERE IS FRACTION OF MAP
   float MoatWidth=iifF(SeaOrLand==1,BaseWidth * (2.9),BaseWidth * (2.9));
   float MyAtX=GetXPointOnCircle(Angle, BaseWidth *.45, AtX); // PUT EACH LAYER ON BACK EDGE OF PREVIOUS
   float MyAtZ=GetZPointOnCircle(Angle, BaseWidth *.45, AtZ); // PUT EACH LAYER ON BACK EDGE OF PREVIOUS*.8175

   int id = CreateAreaAtXZ("PlayerMoat"+ObjName, MyAtX, MyAtZ, MoatWidth,MoatWidth, 2, 1);
   rmSetAreaBaseHeight(id,SeaLevel+3);
   if (SeaOrLand==1) rmSetAreaWaterType(id, GetSeaType());
   else rmSetAreaWaterType(id, GetLakeType());
   rmAddAreaToClass(id, classPlayer);
   rmBuildArea(id);
   string TopSurface="";
   id = CreateAreaAtXZ("PlayerBeach"+ObjName, MyAtX, MyAtZ, BaseWidth * 1.5, BaseWidth * 1.5, 2, 1);
   SetMainLandType(id, 6, 0);
   rmAddAreaToClass(id, classPlayer);
   rmBuildArea(id);
   for (i=0;<=Steps) {
      float ThisWidth = BaseWidth-BaseWidth/Steps * (i-1); // 0 LEVEL IS BUILT LARGER THAN REQUESTED SIZE TO MAKE A BEACH ON WATER MAPS
      MyAtX=GetXPointOnCircle(Angle, BaseWidth + (BaseWidth-ThisWidth)*.95, AtX); // PUT EACH LAYER ON BACK EDGE OF PREVIOUS
      MyAtZ=GetZPointOnCircle(Angle, BaseWidth + (BaseWidth-ThisWidth)*.95, AtZ); // PUT EACH LAYER ON BACK EDGE OF PREVIOUS*.8175
      float ThisHeight = (Height-SeaLevel+2) * i/Steps+SeaLevel;
      float ThisConherence=(.25+.5/Steps*i); // START WILD AND SET STRUCTURED - GO FROM .25 to .75
      float ThisHeightBlend=(3-(i % 5)); // START VERY SMOOTH AND GET RIGID - GO FROM 4 ON BASE LEVEL TO 0 -
      if (ThisHeightBlend<0) ThisHeightBlend=0; // NEVER GO NEGATIVE
      if (i==0) {
         ThisHeight = SeaLevel+2;
         ThisHeightBlend=3; // FIRST LEVEL BLENDS INTO GROUND WELL
      }
      if (i==Steps) TopSurface=GetRoadType();
      id = CreateAreaAtXZ(ObjName+i, MyAtX, MyAtZ, ThisWidth, ThisWidth, ThisHeightBlend ,1); //ThisConherence);
      SetMainLandType(id, 6, ThisHeight,TopSurface);
      if (i>0) { // FIRST LEVEL IS NOT A CLIFF
         rmSetAreaCliffType(id, GetCliffType());
         float PctOfEdge = 1.0;
         int NumRamps = 3;
         if (i+2>Steps) PctOfEdge=.30;
         else if (i+1>Steps) PctOfEdge=.29;
         if (cMapSize==0 && PctOfEdge!=1.0) PctOfEdge = PctOfEdge - .01;
         rmSetAreaCliffEdge(id, NumRamps, PctOfEdge, 0.0, 1, 2);
         rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
         rmSetAreaCliffHeight(id, 2, 1.0, 1.0);
      }
      rmAddAreaToClass(id, classPlayer);
      rmBuildAllAreas();
   }
   if (PlayerId>0) {
      rmPlacePlayer(PlayerId,MyAtX,MyAtZ);
      rmSetPlayerArea(PlayerId, id);
   }
   if (MapSkin==5) {
      FlamingMoat("FlamingMoe1"+Angle,(Angle+180) % 360,5,BaseWidth * 6.2,AtX, AtZ);
      FlamingMoat("FlamingMoe2"+Angle,(Angle+180) % 360,5,BaseWidth * 6,AtX, AtZ);
      FlamingMoat("FlamingMoe3"+Angle,(Angle+180) % 360,5,BaseWidth * 5.8,AtX, AtZ);
      FlamingMoat("FlamingMoe4"+Angle,(Angle+180) % 360,5,BaseWidth * 5.6,AtX, AtZ);
   }
}

int MakeRamp(string ObjName="", float Angle=0, float LineLength=0, float NumSteps=1, float StartX=.5, float StartZ=.5, float StartHeight=15, float Width=0, int classPlayer=0, int classRamp=0) {
   // LineLength  SPACEBETWEEN AS METERS!
   float NextPoint=0;
   float Riser=(StartHeight-SeaLevel+1)/NumSteps;
   int StepsLength = LineLength/NumSteps;
   for (i=(NumSteps * .35); <NumSteps*.9) { // MY OWN HEIGHT BLENDING
      NextPoint = rmZMetersToFraction(i * LineLength/NumSteps);
      float MyAtX=GetXPointOnCircle(Angle, NextPoint, StartX);
      float MyAtZ=GetZPointOnCircle(Angle, NextPoint, StartZ);
      int id = CreateAreaAtXZ(ObjName+"flat"+i, MyAtX, MyAtZ, rmZMetersToFraction(Width*2),rmZMetersToFraction(Width*2), 3, 1);
      SetMainLandType(id, 6, (StartHeight-(Riser * i)-SeaLevel) * .65,GetRoadType());
      rmSetAreaCliffType(id, GetCliffType());
      rmSetAreaCliffEdge(id, 1, 1.0, 0.0, 1.0, 0);
      rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(id, 1, 1.0, 1.0);
   }
   rmBuildAllAreas();
   for (i=1; <=NumSteps) {
      NextPoint = rmZMetersToFraction(i * LineLength/NumSteps);
      MyAtX=GetXPointOnCircle(Angle, NextPoint, StartX);
      MyAtZ=GetZPointOnCircle(Angle, NextPoint, StartZ);
      id = CreateAreaAtXZ(ObjName+"ramp"+i, MyAtX, MyAtZ, rmZMetersToFraction(Width),rmZMetersToFraction(Width), 1, 1);
      SetMainLandType(id, 6, StartHeight-(Riser * i)-SeaLevel-2,GetRoadType());
      rmAddAreaToClass(id, classPlayer);
      rmAddAreaToClass(id, classRamp);
   }
   rmBuildAllAreas();
   return(id);
}


void main(void) {
/* CONSTANTS ************************************/
   SeaOrLand=cMapSize;
   WaterOnMap=SeaOrLand;
   int myTiles = iifF(SeaOrLand==0,12000,20000);
   int mySize = 2 * sqrt(cNumberPlayers * myTiles);
   MapSkin = rmRandInt(1,100);  // I don't like hades,so only do it rarely, very.
   if (MapSkin>5) MapSkin = rmRandInt(1,4);
//   MapSkin=2;
   float pct=1.0;

   rmSetStatusText("",pct);
   pct = pct-0.05;

   float MyAtX=0;
   float MyAtZ=0;
   int id=0;
   rmSetMapSize(mySize,mySize); // METERS
   rmSetSeaLevel(SeaLevel);
   rmSetSeaType(GetSeaType());
   // Is It Sea Or Land Based?
   if (SeaOrLand==0) rmTerrainInitialize(GetLandType());
   else {
      rmTerrainInitialize("water");
   }

   // Define some classes.
   int classTownCenters=rmDefineClass("classTownCenters");
   int classPlayer=rmDefineClass("classPlayer");
   int classRamp=rmDefineClass("classRamp");
   int classCliffs=rmDefineClass("classCliffs");
   int classLand=rmDefineClass("classLand");
   int classForest=rmDefineClass("classForest");
   int classLakes=rmDefineClass("classLakes");
   int classAnimals=rmDefineClass("classAnimals");

   // Keep Things Off The Map Edges
   avoidMapEdgesVeryShort=rmCreateBoxConstraint("Avoid Edge Very Short", rmXTilesToFraction(avoidMapEdgesVeryShort), rmZTilesToFraction(avoidMapEdgesVeryShort), 1.0-rmXTilesToFraction(avoidMapEdgesVeryShort), 1.0-rmZTilesToFraction(avoidMapEdgesVeryShort),0.01);
   avoidMapEdgesShort=rmCreateBoxConstraint("Avoid Edge Short", rmXTilesToFraction(avoidMapEdgesShort), rmZTilesToFraction(avoidMapEdgesShort), 1.0-rmXTilesToFraction(avoidMapEdgesShort), 1.0-rmZTilesToFraction(avoidMapEdgesShort),0.01);
   avoidMapEdgesMedium=rmCreateBoxConstraint("Avoid Edge Medium", rmXTilesToFraction(avoidMapEdgesMedium), rmZTilesToFraction(avoidMapEdgesMedium), 1.0-rmXTilesToFraction(avoidMapEdgesMedium), 1.0-rmZTilesToFraction(avoidMapEdgesMedium),0.01);
   avoidMapEdgesLong=rmCreateBoxConstraint("Avoid Edge Long", rmXTilesToFraction(avoidMapEdgesLong), rmZTilesToFraction(avoidMapEdgesLong), 1.0-rmXTilesToFraction(avoidMapEdgesLong), 1.0-rmZTilesToFraction(avoidMapEdgesLong),0.01);
   avoidMapEdgesVeryLong=rmCreateBoxConstraint("Avoid Edge VeryLong", rmXTilesToFraction(avoidMapEdgesVeryLong), rmZTilesToFraction(avoidMapEdgesVeryLong), 1.0-rmXTilesToFraction(avoidMapEdgesVeryLong), 1.0-rmZTilesToFraction(avoidMapEdgesVeryLong),0.01);

      // Used For Various Land Masses
   avoidLandAreaShort=rmCreateClassDistanceConstraint("Avoid Other Land Short", classLand, avoidLandAreaShort);
   avoidLandAreaMedium=rmCreateClassDistanceConstraint("Avoid Other Land Medium", classLand, avoidLandAreaMedium);
   avoidLandAreaLong=rmCreateClassDistanceConstraint("Avoid Other Land Long", classLand, avoidLandAreaLong);

      // Used For Various Cliffs/Gorges
   avoidCliffsGorgesShort=rmCreateClassDistanceConstraint("Avoid CliffsGorges Short", classCliffs, avoidCliffsGorgesShort);
   avoidCliffsGorgesMedium=rmCreateClassDistanceConstraint("Avoid CliffsGorges Medium", classCliffs, avoidCliffsGorgesMedium);
   avoidCliffsGorgesLong=rmCreateClassDistanceConstraint("Avoid CliffsGorges Long", classCliffs, avoidCliffsGorgesLong);

      // Animals
   avoidAnimalsShort=rmCreateClassDistanceConstraint("Avoid Other Animals Short", classAnimals, avoidAnimalsShort);
   avoidAnimalsMedium=rmCreateClassDistanceConstraint("Avoid Other Animals Medium", classAnimals, avoidAnimalsMedium);
   avoidAnimalsLong=rmCreateClassDistanceConstraint("Avoid Other Animals Long", classAnimals, avoidAnimalsLong);

      // Player Areas Constraint
   avoidPlayerAreasVeryShort=rmCreateClassDistanceConstraint("Avoid Players Areas VeryShort", classPlayer, avoidPlayerAreasVeryShort);
   avoidPlayerAreasShort=rmCreateClassDistanceConstraint("Avoid Players Areas Short", classPlayer, avoidPlayerAreasShort);
   avoidPlayerAreasMedium=rmCreateClassDistanceConstraint("Avoid Players Areas Medium", classPlayer, avoidPlayerAreasMedium);
   avoidPlayerAreasLong=rmCreateClassDistanceConstraint("Avoid Players Areas Long", classPlayer, avoidPlayerAreasLong);
   avoidPlayerAreasVeryLong=rmCreateClassDistanceConstraint("Avoid Players Areas VeryLong", classPlayer, avoidPlayerAreasVeryLong);
      // Player Ramp Constraint
   avoidPlayerRampShort=rmCreateClassDistanceConstraint("Avoid Players Ramp Short", classRamp, avoidPlayerRampShort);
   avoidPlayerRampMedium=rmCreateClassDistanceConstraint("Avoid Players Ramp Medium", classRamp, avoidPlayerRampMedium);
   avoidPlayerRampLong=rmCreateClassDistanceConstraint("Avoid Players Ramp Long", classRamp, avoidPlayerRampLong);

      // Lakes Constraint
   avoidLakesVeryShort=rmCreateClassDistanceConstraint("Avoid Lakes VeryShort", classLakes, avoidLakesVeryShort);
   avoidLakesShort=rmCreateClassDistanceConstraint("Avoid Lakes Short", classLakes, avoidLakesShort);
   avoidLakesMedium=rmCreateClassDistanceConstraint("Avoid Lakes Medium", classLakes, avoidLakesMedium);
   avoidLakesLong=rmCreateClassDistanceConstraint("Avoid Lakes Long", classLakes, avoidLakesLong);
   avoidLakesVeryLong=rmCreateClassDistanceConstraint("Avoid Lakes VeryLong", classLakes, avoidLakesVeryLong);

      // Town Centers constraint.
   avoidTownCentersShort=rmCreateClassDistanceConstraint("avoid TownCenters Short", classTownCenters, avoidTownCentersShort);
   avoidTownCentersMedium=rmCreateClassDistanceConstraint("avoid TownCenters Medium", classTownCenters, avoidTownCentersMedium);
   avoidTownCentersLong=rmCreateClassDistanceConstraint("avoid TownCenters Long", classTownCenters, avoidTownCentersLong);

      // Building constraints - Used For Additional Settlements
   avoidBuildingsVeryShort=rmCreateTypeDistanceConstraint("Avoid Buildings VeryShort", "Building", avoidBuildingsVeryShort);
   avoidBuildingsShort=rmCreateTypeDistanceConstraint("Avoid Buildings Short", "Building", avoidBuildingsShort);
   avoidBuildingsMedium=rmCreateTypeDistanceConstraint("Avoid Buildings Medium", "Building", avoidBuildingsMedium);
   avoidBuildingsLong=rmCreateTypeDistanceConstraint("Avoid Buildings Long", "Building", avoidBuildingsLong);
   avoidBuildingsVeryLong=rmCreateTypeDistanceConstraint("Avoid Buildings VeryLong", "Building", avoidBuildingsVeryLong);

      // Gold
   avoidGoldShort=rmCreateTypeDistanceConstraint("avoid Gold Short", "gold", avoidGoldShort);
   avoidGoldMedium=rmCreateTypeDistanceConstraint("avoid Gold Medium", "gold", avoidGoldMedium);
   avoidGoldLong=rmCreateTypeDistanceConstraint("avoid Gold Long", "gold", avoidGoldLong);

      // Relics
   avoidRelicShort=rmCreateTypeDistanceConstraint("avoid Relics Short", "relic", avoidRelicShort);
   avoidRelicMedium=rmCreateTypeDistanceConstraint("avoid Relics Medium", "relic", avoidRelicMedium);
   avoidRelicLong=rmCreateTypeDistanceConstraint("avoid Relics Long", "relic", avoidRelicLong);

      // Avoid impassable land
   avoidImpassableLandShort=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Short", "land", false, avoidImpassableLandShort);
   avoidImpassableLandMedium=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Medium", "land", false, avoidImpassableLandMedium);
   avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Long", "land", false, avoidImpassableLandLong);

      // Forests
   avoidForestShort=rmCreateClassDistanceConstraint("Avoid Forest Short", classForest, avoidForestShort);
   avoidForestMedium=rmCreateClassDistanceConstraint("Avoid Forest Medium", classForest, avoidForestMedium);
   avoidForestLong=rmCreateClassDistanceConstraint("Avoid Forest Long", classForest, avoidForestLong);

      // Avoid Water
   avoidWaterVeryShort=rmCreateTerrainDistanceConstraint("avoid water very short", "land", false, avoidWaterVeryShort);
   avoidWaterShort=rmCreateTerrainDistanceConstraint("avoid water short", "land", false, avoidWaterShort);
   avoidWaterMedium=rmCreateTerrainDistanceConstraint("avoid water medium", "land", false, avoidWaterMedium);
   avoidWaterLong=rmCreateTerrainDistanceConstraint("avoid water Long", "land", false, avoidWaterLong);

   // Near To Water
   nearShoreLineVeryShort=rmCreateTerrainMaxDistanceConstraint("near shoreline very short", "water", true, nearShoreLineVeryShort);
   nearShoreLineShort=rmCreateTerrainMaxDistanceConstraint("near shoreline short", "water", true, nearShoreLineShort);
   nearShoreLineMedium=rmCreateTerrainMaxDistanceConstraint("near shoreline medium", "water", true, nearShoreLineMedium);
   nearShoreLineLong=rmCreateTerrainMaxDistanceConstraint("near shoreline long", "water", true, nearShoreLineLong);

   // Near To Land
   nearLandVeryShort=rmCreateTerrainMaxDistanceConstraint("near Land very short", "land", true, nearLandVeryShort);
   nearLandShort=rmCreateTerrainMaxDistanceConstraint("near Land short", "land", true, nearLandShort);
   nearLandMedium=rmCreateTerrainMaxDistanceConstraint("near Land medium", "land", true, nearLandMedium);
   nearLandLong=rmCreateTerrainMaxDistanceConstraint("near Land long", "land", true, nearLandLong);

      // Avoid All Objects
   avoidAllVeryShort=rmCreateTypeDistanceConstraint("avoid all very short", "all", avoidAllVeryShort);
   avoidAllShort=rmCreateTypeDistanceConstraint("avoid all short", "all", avoidAllShort);
   avoidAllMedium=rmCreateTypeDistanceConstraint("avoid all medium", "all", avoidAllMedium);
   avoidAllLong=rmCreateTypeDistanceConstraint("avoid all long", "all", avoidAllLong);

   // Keep Off Shore
   int avoidLandShoreLineShort = rmCreateTerrainDistanceConstraint("avoidLandShoreLine", "land", true, cShort);

   rmSetStatusText("",pct);
   pct = pct-0.05;

   // -------------Define objects
   idTree1=rmCreateObjectDef("random tree1"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree1, GetTreeType(0), 3, 1);
   idTree2=rmCreateObjectDef("random tree2"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree2, GetTreeType(0), 3, 1);
   idTree3=rmCreateObjectDef("random tree3"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree3, GetTreeType(0), 3, 1);
   idTree4=rmCreateObjectDef("random tree"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree4, GetTreeType(0), 3, 1);
   rmAddObjectDefConstraint(idTree1, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree2, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree3, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree4, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree1, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree2, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree3, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree4, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree1, avoidPlayerRampShort);
   rmAddObjectDefConstraint(idTree2, avoidPlayerRampShort);
   rmAddObjectDefConstraint(idTree3, avoidPlayerRampShort);
   rmAddObjectDefConstraint(idTree4, avoidPlayerRampShort);

   // -------------Done defining objects

   rmSetStatusText("",pct);
   pct = pct-0.05;

   if (SeaOrLand==1) {// NEED MAIN LAND
      float MainLandMinSize=.4;
      float MainLandMaxSize=.6;
      id = CreateAreaAtXZ("Center", .5, .5, rmRandFloat(MainLandMinSize,MainLandMaxSize), rmRandFloat(MainLandMinSize,MainLandMaxSize), 2.0, 0);
      SetMainLandType(id, 20, SeaLevel+4.0);
      rmSetAreaSmoothDistance(id, 12);
      rmAddAreaConstraint(id, avoidPlayerAreasVeryShort);
      rmAddAreaConstraint(id, avoidMapEdgesShort);
      rmBuildAllAreas();
   }
   float PlayerFraction=rmZMetersToFraction(25);
//   float PlayerFraction=rmAreaTilesToFraction(2000);
   float PlayerAreaHeight=2;
   float PlayerAreaRampWidth=1.5; //.75;
   float PlayerAreaRampLength=iifF(SeaOrLand==0,95,120);
   float MountainEdgeDist = PlayerFraction * (SeaOrLand+cNumberPlayers+1);
   MountainEdgeDist = MountainEdgeDist+iifF(cNumberPlayers<5,PlayerFraction,0);

   int StartCorner = rmRandInt(1,4); // PICK A RANDOM START CORNER
   int Corner1=0; // SINCE THIS MAP PLACES PLAYERS
   int Corner2=0; // AT EXACT MAP LOCATIONS
   int Corner3=0; // AT LEAST START PLAYER 1 IN
   int Corner4=0; // A DIFFERENT SPOT EACH TIME
   if (StartCorner==1) {
      Corner1 = 1;
      Corner2 = 2;
      if (cNumberPlayers>3) Corner3 = 3;
      if (cNumberPlayers>4) Corner4 = 4;
   }
   if (StartCorner==2) {
      Corner1 = 2;
      Corner2 = 1;
      if (cNumberPlayers>3) Corner4 = 3;
      if (cNumberPlayers>4) Corner3 = 4;
   }
   if (StartCorner==3) {
      Corner3 = 1;
      Corner4 = 2;
      if (cNumberPlayers>3) Corner1 = 3;
      if (cNumberPlayers>4) Corner2 = 4;
   }
   if (StartCorner==4) {
      Corner3 = 2;
      Corner4 = 1;
      if (cNumberPlayers>3) Corner2 = 3;
      if (cNumberPlayers>4) Corner1 = 4;
   }

   if (Corner1>0) {
      MyAtX=GetXPointOnCircle(225, (MountainEdgeDist), 1); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(225, (MountainEdgeDist), 1);
      BuildMountainAtXZ("BuildKeep45", 45, MyAtX, MyAtZ,  PlayerFraction, PlayerAreaHeight, 3, Corner1, classPlayer);
      MyAtX=GetXPointOnCircle(225, (MountainEdgeDist *.9), 1);
      MyAtZ=GetZPointOnCircle(225, (MountainEdgeDist *.9), 1);
      MakeRamp("KeepStep225", 225, PlayerAreaRampLength, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classPlayer, classRamp);
      PlayerStash("Stash11", 1, 1, nearShoreLineVeryShort);
   }
   if (Corner2>0) {
      MyAtX=GetXPointOnCircle(45, (MountainEdgeDist), 0);
      MyAtZ=GetZPointOnCircle(45, (MountainEdgeDist), 0);
      BuildMountainAtXZ("BuildKeep225", 225, MyAtX, MyAtZ,  PlayerFraction, PlayerAreaHeight, 3, Corner2, classPlayer);
      MyAtX=GetXPointOnCircle(45, (MountainEdgeDist *.9), 0);
      MyAtZ=GetZPointOnCircle(45, (MountainEdgeDist *.9), 0);
      MakeRamp("KeepStep45", 45, PlayerAreaRampLength, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classPlayer, classRamp);
      PlayerStash("Stash00", 0, 0, nearShoreLineVeryShort);
   }
   if (Corner3>0) {
      MyAtX=GetXPointOnCircle(135, (MountainEdgeDist), 1);
      MyAtZ=GetZPointOnCircle(135, (MountainEdgeDist), 0);
      BuildMountainAtXZ("BuildKeep315", 315, MyAtX, MyAtZ,  PlayerFraction, PlayerAreaHeight, 3, Corner3, classPlayer);
      MyAtX=GetXPointOnCircle(135, (MountainEdgeDist *.9), 1);
      MyAtZ=GetZPointOnCircle(135, (MountainEdgeDist *.9), 0);
      MakeRamp("KeepStep135", 135, PlayerAreaRampLength, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classPlayer, classRamp);
      PlayerStash("Stash10", 1, 0, nearShoreLineVeryShort);
   }
   if (Corner4>0) {
      MyAtX=GetXPointOnCircle(315, (MountainEdgeDist), 0);
      MyAtZ=GetZPointOnCircle(315, (MountainEdgeDist), 1);
      BuildMountainAtXZ("BuildKeep135", 135, MyAtX, MyAtZ,  PlayerFraction, PlayerAreaHeight, 3, Corner4, classPlayer);
      MyAtX=GetXPointOnCircle(315, (MountainEdgeDist *.9), 0);
      MyAtZ=GetZPointOnCircle(315, (MountainEdgeDist *.9), 1);
      MakeRamp("KeepStep315", 315, PlayerAreaRampLength, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classPlayer, classRamp);
      PlayerStash("Stash01", 0, 1, nearShoreLineVeryShort);
   }

   rmSetStatusText("",pct);
   pct = pct-0.05;
   int NumCliffs = rmRandInt(cNumberPlayers,cNumberPlayers+3);
   int NumWaterAreas = 0;
   rmSetStatusText("",pct);
   pct = pct-0.05;
   if (rmRandInt(1,2)==1) {
      rmSetStatusText("and created Lakes...",0.15);
      NumWaterAreas = rmRandInt(cNumberPlayers,cNumberPlayers+3);
      WaterArea("Lakes",NumWaterAreas,rmRandInt(5,10),rmRandInt(10,20),rmRandInt(3,7), rmRandInt(3,10), classLakes,avoidPlayerAreasShort);
      WaterOnMap=1;
   }
   CliffArea("Cliffs",NumCliffs-NumWaterAreas,4,7,rmRandInt(5,10),rmRandInt(5,10), classLand, avoidImpassableLandMedium, avoidPlayerAreasMedium, avoidLakesVeryShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;
   LandArea("NooksCranies",cNumberPlayers*5,-5,4,5,rmRandInt(5,10), classLand, 0, avoidImpassableLandShort, avoidPlayerAreasShort, avoidLakesVeryShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;
   ForestArea("ForestLarge",cNumberPlayers*2,5,rmRandInt(10,20), classForest, avoidPlayerAreasShort, avoidForestMedium, avoidLakesVeryShort);
   ForestArea("ForestSmall",cNumberPlayers*2,5,rmRandInt(2,5), classForest, avoidPlayerAreasShort, avoidForestMedium, avoidLakesVeryShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // TC
   int TownCenterId=rmCreateObjectDef("TownCenter");
   rmAddObjectDefItem(TownCenterId, "Settlement Level 1", 1, 0.0);
   rmAddObjectDefToClass(TownCenterId, classTownCenters);
   rmSetObjectDefMinDistance(TownCenterId, 0.0);
   rmSetObjectDefMaxDistance(TownCenterId, 3.0);
   rmAddObjectDefConstraint(TownCenterId, avoidWaterShort);
   rmAddObjectDefConstraint(TownCenterId, avoidMapEdgesShort);
   rmPlaceObjectDefPerPlayer(TownCenterId, true);

   // Towers
   int TowerId=rmCreateObjectDef("Tower");
   rmAddObjectDefItem(TowerId, "tower", 1, 0.0);
   float FirstTower = rmZMetersToFraction(iifF(cMapSize==0,40,31));
   float SecondTower = rmZMetersToFraction(iifF(cMapSize==0,75,95));
   int TA=0;
   MountainEdgeDist=MountainEdgeDist-rmXMetersToFraction(40);
   PlayerAreaRampLength=PlayerAreaRampLength+20;
   int TowerSpacing = PlayerAreaRampLength / 4;
   int SwingOut = 10+cMapSize*2;
   if (Corner1>0) {
      TA = 225;
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 1); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 1);
      MyAtX=GetXPointOnCircle(TA-90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA-90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner1);
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 1); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 1);
      MyAtX=GetXPointOnCircle(TA+90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA+90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner1);
//      ObjectsInACircle(TowerId, 176, 274, 98, FirstTower, MyAtX, MyAtZ, Corner1, 1);
//      ObjectsInACircle(TowerId, 215, 235, 20, SecondTower, MyAtX, MyAtZ, Corner1, 1);
   }
   if (Corner2>0) {
      TA = 405;
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 0); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 0);
      MyAtX=GetXPointOnCircle(TA-90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA-90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner2);
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 0); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 0);
      MyAtX=GetXPointOnCircle(TA+90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA+90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner2);
   }
   if (Corner3>0) {
      TA = 135;
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 1); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 0);
      MyAtX=GetXPointOnCircle(TA-90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA-90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner3);
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 1); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 0);
      MyAtX=GetXPointOnCircle(TA+90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA+90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner3);
   }
   if (Corner4>0) {
      TA = 315;
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 0); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 1);
      MyAtX=GetXPointOnCircle(TA-90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA-90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner4);
      MyAtX=GetXPointOnCircle(TA, (MountainEdgeDist), 0); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(TA, (MountainEdgeDist), 1);
      MyAtX=GetXPointOnCircle(TA+90, rmXMetersToFraction(SwingOut), MyAtX);
      MyAtZ=GetZPointOnCircle(TA+90, rmZMetersToFraction(SwingOut), MyAtZ);
      ObjectsInALine(TowerId, TA, PlayerAreaRampLength, TowerSpacing, MyAtX, MyAtZ, Corner4);
   }
   rmSetObjectDefMinDistance(TowerId, 18.0);
   rmSetObjectDefMaxDistance(TowerId, 24.0);
   rmAddObjectDefConstraint(TowerId, avoidBuildingsMedium);
   rmAddObjectDefConstraint(TowerId, avoidPlayerRampShort);
   rmPlaceObjectDefPerPlayer(TowerId, true, 4);

   rmSetStatusText("",pct);
   pct = pct-0.05;

   // Settlements
   int SettlementId=rmCreateObjectDef("far settlement");
   rmAddObjectDefItem(SettlementId, "Settlement", 1, 0.0);
   rmAddObjectDefConstraint(SettlementId, avoidMapEdgesShort);
   rmAddObjectDefConstraint(SettlementId, avoidWaterVeryShort);
   rmAddObjectDefConstraint(SettlementId, avoidPlayerRampMedium);
   rmSetObjectDefMinDistance(SettlementId, 75);
   rmSetObjectDefMaxDistance(SettlementId, 80);
   rmPlaceObjectDefPerPlayer(SettlementId, false ,1);
   rmAddObjectDefConstraint(SettlementId, avoidBuildingsVeryLong); // OTHER SETTLEMENTS
   rmAddObjectDefConstraint(SettlementId, avoidPlayerAreasShort);
   int NearOrFar=rmRandInt(1,2); // ALWAYS PLACE ONE MORE, MAYBE PLACE BOTH
   if (rmRandInt(1,2)==1 || NearOrFar==1) {
      rmSetObjectDefMinDistance(SettlementId, rmZFractionToMeters(.25));
      rmSetObjectDefMaxDistance(SettlementId, rmZFractionToMeters(.4));
      rmPlaceObjectDefPerPlayer(SettlementId, false ,1);
   }
   if (rmRandInt(1,2)==1 || NearOrFar==2) {
      rmSetObjectDefMinDistance(SettlementId, rmZFractionToMeters(.4));
      rmSetObjectDefMaxDistance(SettlementId, rmZFractionToMeters(.7));
      rmPlaceObjectDefPerPlayer(SettlementId, false ,1);
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // Transports
   if (SeaOrLand==1) { // SEA MAPS GET TRANSPORTS
      int transportGreekID=rmCreateObjectDef("transport Greek");
      rmAddObjectDefItem(transportGreekID, "transport ship Greek", 1, 0.0);
      rmSetObjectDefMinDistance(transportGreekID, 0.0);
      rmSetObjectDefMaxDistance(transportGreekID, 105.0);
      rmAddObjectDefConstraint(transportGreekID, nearShoreLineShort);
      rmAddObjectDefConstraint(transportGreekID, avoidMapEdgesShort);
      int transportNorseID=rmCreateObjectDef("transport Norse");
      rmAddObjectDefItem(transportNorseID, "transport ship Norse", 1, 0.0);
      rmSetObjectDefMinDistance(transportNorseID, 0.0);
      rmSetObjectDefMaxDistance(transportNorseID, 105.0);
      rmAddObjectDefConstraint(transportNorseID, nearShoreLineShort);
      rmAddObjectDefConstraint(transportNorseID, avoidMapEdgesShort);
      int transportEgyptianID=rmCreateObjectDef("transport Egyptian");
      rmAddObjectDefItem(transportEgyptianID, "transport ship Egyptian", 1, 0.0);
      rmSetObjectDefMinDistance(transportEgyptianID, 0.0);
      rmSetObjectDefMaxDistance(transportEgyptianID, 105.0);
      rmAddObjectDefConstraint(transportEgyptianID, nearShoreLineShort);
      rmAddObjectDefConstraint(transportEgyptianID, avoidMapEdgesShort);
      for(i=0; <cNumberPlayers) {
         if(rmGetPlayerCulture(i) == cCultureGreek) rmPlaceObjectDefAtLoc(transportGreekID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
         else if(rmGetPlayerCulture(i) == cCultureNorse) rmPlaceObjectDefAtLoc(transportNorseID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
         else if(rmGetPlayerCulture(i) == cCultureEgyptian) rmPlaceObjectDefAtLoc(transportEgyptianID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      }
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // FOOD UP THE MAP - - HerdHuntFishPred
   int NotTooMuch=1;
   int HuntFoodGroups=1+rmRandInt(0,1);
   int HerdFoodGroups=1+rmRandInt(0,1);

   // REAL CLOSE HERD FOOD
   for(i=1; <=(HerdFoodGroups)) {
      id = CreateAnimals("closeHerd"+i, 1, 15, 18, classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // NEAR HERD FOOD
   for(i=1; <=(HerdFoodGroups)) {
      id = CreateAnimals("nearHerd"+i, 1, rmZFractionToMeters(.2), rmZFractionToMeters(.33), classAnimals, avoidMapEdgesMedium, avoidForestMedium, avoidAnimalsMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // FAR HERD FOOD
   for(i=1; <=HerdFoodGroups/NotTooMuch) {
      id = CreateAnimals("farHerd"+i, 1, rmZFractionToMeters(.33), rmZFractionToMeters(.65), classAnimals, avoidMapEdgesMedium, avoidForestMedium, avoidPlayerAreasLong, avoidAnimalsMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;
   // REAL CLOSE HUNTABLE FOOD
   for(i=1; <=(HuntFoodGroups)) {
      id = CreateAnimals("closeHunt"+i, 2,  15,25, classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // NEAR BY HUNTABLE FOOD
   for(i=1; <=(HuntFoodGroups)) {
      id = CreateAnimals("nearHunt"+i, 2, rmZFractionToMeters(.2), rmZFractionToMeters(.33), classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // FAR AWAY HUNTABLE FOOD
   for(i=1; <=HuntFoodGroups/NotTooMuch) {
      id = CreateAnimals("farHunt"+i, 2, rmZFractionToMeters(.33), rmZFractionToMeters(.65), classAnimals, avoidPlayerAreasLong);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }

   // NEAR BY PREDATORS
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("nearPredator"+i, 4, rmZFractionToMeters(.15), rmZFractionToMeters(.25), classAnimals, avoidPlayerAreasShort, avoidAnimalsMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // FAR AWAY PREDATORS
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("farPredator"+i, 4, rmZFractionToMeters(.25), rmZFractionToMeters(.65), classAnimals, avoidBuildingsLong, avoidAnimalsMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // REAL CLOSE FISHES
   int NumFishes=rmRandInt(3,10);
   for(i=1; <=NumFishes) {
      id = CreateAnimals("closeFish"+i, 3, 15, 100, classAnimals, avoidAnimalsMedium);
      rmAddObjectDefConstraint(id, nearShoreLineShort);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   if (SeaOrLand==1) { // IF WATER BASED...
      NumFishes=rmRandInt(6,10);
      // NEAR TO FAR AWAY FISH FOOD
      for(i=1; <=NumFishes) {
         id = CreateAnimals("farFish"+i, 3, 100, rmZFractionToMeters(.9), classAnimals, avoidAnimalsMedium);
         rmAddObjectDefConstraint(id, nearShoreLineMedium);
         rmPlaceObjectDefPerPlayer(id, false, 1);
      }
      string str="";
      str="Seaweed";
      id=rmCreateObjectDef("weed"+str+i);
      rmAddObjectDefItem(id, str, 3, 2.0);
      rmAddObjectDefConstraint(id, nearLandShort);
      rmAddObjectDefConstraint(id, avoidLakesVeryShort);
      rmSetObjectDefMinDistance(id, 0.3);
      rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
      for(i=1; <=cNumberPlayers) {
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, cNumberPlayers * 5 / NotTooMuch);
      }
      for(i=1; <=cNumberPlayers) {
         str=GetBigFish();
         id=rmCreateObjectDef("bigfish"+str+i);
         rmAddObjectDefItem(id, str, 1, 0.0);
         rmAddObjectDefConstraint(id, avoidLakesVeryShort);
         rmAddObjectDefConstraint(id, avoidMapEdgesShort);
         rmAddObjectDefConstraint(id, avoidLandShoreLineShort);

         rmSetObjectDefMinDistance(id, 0.3);
         rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, cNumberPlayers / NotTooMuch);
      }
   }
   for(i=1; <=cNumberPlayers) {
      str=GetWaterPlant();
      id=rmCreateObjectDef("waterplant"+str+i);
      rmAddObjectDefItem(id, str, 1, 0.0);
      rmAddObjectDefConstraint(id, avoidLakesVeryShort);
      rmAddObjectDefConstraint(id, nearLandShort);
      rmSetObjectDefMinDistance(id, 15);
      rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
      rmPlaceObjectDefPerPlayer(id, false, cNumberPlayers * 5 / NotTooMuch);
   }

   rmSetStatusText("",pct);
   pct = pct-0.05;

   // GOLD IN THE HILLS
   CreateGold(6000, 30, 6000/rmRandInt(1,3)/NotTooMuch, rmZFractionToMeters(.3), 6000/rmRandInt(1,3)/NotTooMuch, rmZFractionToMeters(.75),avoidPlayerRampShort); // 3 Amount & Distances
   // Relics
   int RelicId=rmCreateObjectDef("relic");
   rmAddObjectDefItem(RelicId, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(RelicId, rmZFractionToMeters(.35));
   rmSetObjectDefMaxDistance(RelicId, rmZFractionToMeters(.75));
   rmAddObjectDefConstraint(RelicId, avoidPlayerAreasLong);
   rmAddObjectDefConstraint(RelicId, avoidRelicLong);
   rmAddObjectDefConstraint(RelicId, avoidAllShort);
   rmPlaceObjectDefPerPlayer(RelicId, false, rmRandInt(1,2));
   // Various Rocks
   AddRocks(5*cNumberPlayers, avoidAllVeryShort, avoidPlayerAreasShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;

   rmSetStatusText("",pct);
   pct = pct-0.05;

   RandomTrees();

  // Text
   rmSetStatusText("",pct);
   pct = pct-0.05;

   id = rmCreateObjectDef("birdfriend");
   rmAddObjectDefItem(id,GetBirdType(),1,0.0);
   rmPlaceObjectDefPerPlayer(id, false, 2);
   rmSetIgnoreForceToGaia(true);
   rmPlaceObjectDefPerPlayer(id, true);

  // **** TRIGGERS ****

   if (rmRandInt(1,5)==1) { // DISPLAY THE CREDIT ONCE IN A WHILE
      rmCreateTrigger("egg");
      rmSwitchToTrigger(rmTriggerID("egg"));
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",1);
      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","*** Stronghold RMS v1 by Cartographer@BeerInHand.com ****");
      rmAddTriggerEffect("Sound Filename");
      rmSetTriggerEffectParam("Sound", "\dialog\skul062.mp3");
      rmSetTriggerPriority(2);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
   }

   // MYTH MATCH TRIGGERS BEGIN
   rmCreateTrigger("MythMatchIntro");
   rmCreateTrigger("MorePlease");
   rmCreateTrigger("NowTheyAreOnSpeed");

   for(i=1; <cNumberPlayers) { // START OFF PLAYERS WITH 420
      rmSetPlayerResource(i, "favor", 42);
      rmSetPlayerResource(i, "food", 420);
      rmSetPlayerResource(i, "wood", 420);
      rmSetPlayerResource(i, "gold", 420);
   }

   int often420 = 60;  // 60 SECONDS GET RESOURCE
   int oftenSpeed = 420; //  420 SECONDS GET FASTER
   rmSwitchToTrigger(rmTriggerID("MythMatchIntro"));
   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("Message", "The High Gods will grant 420 of each resource every " + often420 + " seconds.");
   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("Message", "The High Gods will increase Hero speed and Villager's gather rate every " + oftenSpeed + " minutes.");
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID",rmTriggerID("MorePlease"));
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID",rmTriggerID("NowTheyAreOnSpeed"));
   rmSetTriggerPriority(4);
   rmSetTriggerActive(true);
   rmSetTriggerRunImmediately(true);
   rmSetTriggerLoop(false);

   rmSwitchToTrigger(rmTriggerID("MorePlease"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",often420);
   rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound","tributereceived.wav");
   for(i=1; <= cNumberPlayers){
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Gold");
      rmSetTriggerEffectParamInt("Amount",420);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Food");
      rmSetTriggerEffectParamInt("Amount",420);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Wood");
      rmSetTriggerEffectParamInt("Amount",420);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Favor");
      rmSetTriggerEffectParamInt("Amount",42);
   }
   rmSetTriggerPriority(4);
   rmSetTriggerActive(false);
   rmSetTriggerRunImmediately(false);
   rmSetTriggerLoop(true);

   rmSwitchToTrigger(rmTriggerID("NowTheyAreOnSpeed"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",oftenSpeed);
   rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound","relicselect.wav");
   for(i=1; <cNumberPlayers){
      rmAddTriggerEffect("Set Tech Status"); // HEROS GET FASTER
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("TechID", "367"); //Boots of Kick Everything: Heroes are 20% faster
      rmSetTriggerEffectParam("Status", "4");
      rmAddTriggerEffect("Set Tech Status"); // VILLAGERS GATHER FASTER
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("TechID", "296"); //Harmonia's Necklace: Villager gather rate increased by 10%
      rmSetTriggerEffectParam("Status", "4");
   }
   rmSetTriggerPriority(4);
   rmSetTriggerActive(false);
   rmSetTriggerRunImmediately(false);
   rmSetTriggerLoop(true);
}

